<script setup>
    import {ref, reactive, onMounted, watch } from 'vue';
    import { HttpReq } from '@/utilies/httpRequest';
    import store from '@/store';

    const emits = defineEmits(['addUser', 'editUser'])
    const dialogBox = ref(false)
    const title = ref("")

    const show = ref(false)
    const modeHttp = ref(-1)

    const formInputs = reactive({
        idD: '',
        nameD: '',
        usernameD: '',
        roleD: '',
        passwordD: ''
    })
    const valid = ref(false)
    const form = ref(null)
    const errorAuth = ref("")

    const roles = ref([])

    const nameRule = ref([
        v => !!v || 'Nombre es requerido'
    ])
    const usernameRule = ref([
        v => !!v || 'Nombre de usuario es requerido'
    ])
    const roleRule = ref([
        v => !!v || 'Role es requerido'
    ])
    const passwordRule = ref([
        v => !!v || 'Password es requerido'
    ])

    watch(dialogBox, (dialogBox) => {
        if(!dialogBox)
            form.value.resetValidation()
    })

    onMounted(() => {
        getRoles()
    })

    async function getRoles() {
        let resp = await HttpReq.getData('user/role')
        console.log("resp: ", resp)
        if(resp.status == 200) {
            roles.value = resp.data.map(item => {
                return {
                    text: item.nameD,
                    value: item.idD
                }
            })
        }
    }

    function postModal() {
        title.value = "Crear Usuario"
        formInputs.idD = ""
        formInputs.nameD = ""
        formInputs.roleD = ""
        formInputs.usernameD = ""
        formInputs.passwordD = ""
        dialogBox.value = true
        modeHttp.value = 0
    }

    function putModal(item) {
        formInputs.idD = item.id
        formInputs.nameD = item.name
        formInputs.roleD = item.role.id
        formInputs.usernameD = item.username
        formInputs.passwordD = null

        console.log("item put: ", item)
        title.value = "Editar Usuario"
        dialogBox.value = true
        modeHttp.value = 1
    }

    async function sendData() {
        if(!form.value.validate())
            return
        
        if(modeHttp.value == 0) {
            emits('addUser', 
            {   ...formInputs, 
                role: {
                    idD: "636c276b97aed3f61e26bf4d",
                    nameD: "ROLE_ADMIN"
                } 
            })

            store.dispatch('openModal', {
                title: "Crear usuario",
                body: "El usuario se ha agregao sastifactoriamente",
                type: 0
            })
        }
        if(modeHttp.value == 1) {

            emits('editUser', {
                ...formInputs,
                role: {
                    idD: "636c276b97aed3f61e26bf4d",
                    nameD: "ROLE_ADMIN"
                } 
            })

            store.dispatch('openModal', {
                title: "Editar usuario",
                body: "El usuario se ha editado sastifactoriamente",
                type: 0
            })
        }
        dialogBox.value = false

    }

    defineExpose({
        postModal,
        putModal
    })
</script>

<template>
    <v-row justify="center">
        <v-dialog
            v-model="dialogBox"
            max-width="350"
        >

            <v-form
                ref="form"
                v-model="valid"
                lazy-validation
            >
                
                <v-card>
                    <v-card-title class="text-h5">
                        {{title}}
                    </v-card-title>
                    <v-card-text>
                        <v-text-field
                            label="Nombre"
                            v-model="formInputs.nameD"
                            :rules="nameRule"
                        >
                        </v-text-field>
                        <v-text-field
                            label="Nombre de usuario"
                            v-model="formInputs.usernameD"
                            :rules="usernameRule"
                        >
                        </v-text-field>
                        
                        <v-select
                            v-model="formInputs.roleD"
                            :items="roles"
                            item-text="text"
                            item-value="value"
                            label="Rol de usuario"
                            :rules="roleRule"
                        >
                        </v-select>

                        <v-text-field
                            v-model="formInputs.passwordD"
                            :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
                            :type="show ? 'text' : 'password'"
                            label="Contraseña"
                            @click:append="show = !show"
                            :rules="modeHttp == 0 ? passwordRule : []"
                            :hint="modeHttp == 1 ? 'Este campo es opcional' : ''"
                        >
                        </v-text-field>

                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn
                            color="green darken-1"
                            text
                            @click="sendData()"
                            :disabled="!valid"
                        >
                            Guardar
                        </v-btn>

                        <v-btn
                            color="gray darken-1"
                            text
                            @click="dialogBox = false"
                        >
                            Cancelar
                        </v-btn>
                    </v-card-actions>
                </v-card>

            </v-form>

        </v-dialog>
    </v-row>
</template>

<style>

</style>